package org.xdoclet.plugin.tapestry.qtags;

public class ContribTableViewTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.ContribTableViewTag {
    public static final String NAME = "contrib.table-view";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"table-model",
		"source",
		"columns",
		"page-size",
		"initial-page",
		"initial-sort-column",
		"initial-sort-order",
		"table-session-state-manager",
		"table-session-store-manager",
		"persist",
		"element",
		"column-settings-container",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public ContribTableViewTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public ContribTableViewTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTableModel() {
		boolean required = false;
        String result = getNamedParameter("table-model");
        if(required && result == null) {
            bomb("table-model=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSource() {
		boolean required = false;
        String result = getNamedParameter("source");
        if(required && result == null) {
            bomb("source=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getColumns() {
		boolean required = false;
        String result = getNamedParameter("columns");
        if(required && result == null) {
            bomb("columns=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPageSize() {
		boolean required = false;
        String result = getNamedParameter("page-size");
        if(required && result == null) {
            bomb("page-size=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getInitialPage() {
		boolean required = false;
        String result = getNamedParameter("initial-page");
        if(required && result == null) {
            bomb("initial-page=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getInitialSortColumn() {
		boolean required = false;
        String result = getNamedParameter("initial-sort-column");
        if(required && result == null) {
            bomb("initial-sort-column=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getInitialSortOrder() {
		boolean required = false;
        String result = getNamedParameter("initial-sort-order");
        if(required && result == null) {
            bomb("initial-sort-order=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTableSessionStateManager() {
		boolean required = false;
        String result = getNamedParameter("table-session-state-manager");
        if(required && result == null) {
            bomb("table-session-state-manager=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTableSessionStoreManager() {
		boolean required = false;
        String result = getNamedParameter("table-session-store-manager");
        if(required && result == null) {
            bomb("table-session-store-manager=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPersist() {
		boolean required = false;
        String result = getNamedParameter("persist");
        if(required && result == null) {
            bomb("persist=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getElement() {
		boolean required = false;
        String result = getNamedParameter("element");
        if(required && result == null) {
            bomb("element=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getColumnSettingsContainer() {
		boolean required = false;
        String result = getNamedParameter("column-settings-container");
        if(required && result == null) {
            bomb("column-settings-container=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getTableModel();
        getSource();
        getColumns();
        getPageSize();
        getInitialPage();
        getInitialSortColumn();
        getInitialSortOrder();
        getTableSessionStateManager();
        getTableSessionStoreManager();
        getPersist();
        getElement();
        getColumnSettingsContainer();
    }

    public void validateModel() {
        // check uniqueness
    }
}