package org.xdoclet.plugin.tapestry.qtags;

public class TacosDropTargetTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.TacosDropTargetTag {
    public static final String NAME = "tacos.drop-target";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"accepts-tag-type",
		"drag-source",
		"drag-source-element",
		"drag-source-class",
		"drag-source-tag",
		"drag-source-link",
		"insert-drag-source",
		"on-drag-over",
		"on-drag-out",
		"on-drop",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public TacosDropTargetTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public TacosDropTargetTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAcceptsTagType() {
		boolean required = false;
        String result = getNamedParameter("accepts-tag-type");
        if(required && result == null) {
            bomb("accepts-tag-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDragSource() {
		boolean required = false;
        String result = getNamedParameter("drag-source");
        if(required && result == null) {
            bomb("drag-source=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDragSourceElement() {
		boolean required = false;
        String result = getNamedParameter("drag-source-element");
        if(required && result == null) {
            bomb("drag-source-element=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDragSourceClass() {
		boolean required = false;
        String result = getNamedParameter("drag-source-class");
        if(required && result == null) {
            bomb("drag-source-class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDragSourceTag() {
		boolean required = false;
        String result = getNamedParameter("drag-source-tag");
        if(required && result == null) {
            bomb("drag-source-tag=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDragSourceLink() {
		boolean required = true;
        String result = getNamedParameter("drag-source-link");
        if(required && result == null) {
            bomb("drag-source-link=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getInsertDragSource() {
		boolean required = false;
        String result = getNamedParameter("insert-drag-source");
        if(required && result == null) {
            bomb("insert-drag-source=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOnDragOver() {
		boolean required = false;
        String result = getNamedParameter("on-drag-over");
        if(required && result == null) {
            bomb("on-drag-over=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOnDragOut() {
		boolean required = false;
        String result = getNamedParameter("on-drag-out");
        if(required && result == null) {
            bomb("on-drag-out=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOnDrop() {
		boolean required = false;
        String result = getNamedParameter("on-drop");
        if(required && result == null) {
            bomb("on-drop=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getAcceptsTagType();
        getDragSource();
        getDragSourceElement();
        getDragSourceClass();
        getDragSourceTag();
        getDragSourceLink();
        getInsertDragSource();
        getOnDragOver();
        getOnDragOut();
        getOnDrop();
    }

    public void validateModel() {
        // check uniqueness
    }
}