package org.xdoclet.plugin.tapestry.qtags;

public class TacosPartialForTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.TacosPartialForTag {
    public static final String NAME = "tacos.partial-for";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"source",
		"value",
		"index",
		"element",
		"key-expression",
		"full-source",
		"default-value",
		"converter",
		"primary-keys",
		"key-provider",
		"match",
		"volatile",
		"partial-block",
		"even-odd",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public TacosPartialForTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public TacosPartialForTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSource() {
		boolean required = true;
        String result = getNamedParameter("source");
        if(required && result == null) {
            bomb("source=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getValue_() {
		boolean required = false;
        String result = getNamedParameter("value");
        if(required && result == null) {
            bomb("value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getIndex() {
		boolean required = false;
        String result = getNamedParameter("index");
        if(required && result == null) {
            bomb("index=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getElement() {
		boolean required = false;
        String result = getNamedParameter("element");
        if(required && result == null) {
            bomb("element=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getKeyExpression() {
		boolean required = false;
        String result = getNamedParameter("key-expression");
        if(required && result == null) {
            bomb("key-expression=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getFullSource() {
		boolean required = false;
        String result = getNamedParameter("full-source");
        if(required && result == null) {
            bomb("full-source=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDefaultValue() {
		boolean required = false;
        String result = getNamedParameter("default-value");
        if(required && result == null) {
            bomb("default-value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getConverter() {
		boolean required = false;
        String result = getNamedParameter("converter");
        if(required && result == null) {
            bomb("converter=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPrimaryKeys() {
		boolean required = false;
        String result = getNamedParameter("primary-keys");
        if(required && result == null) {
            bomb("primary-keys=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getKeyProvider() {
		boolean required = false;
        String result = getNamedParameter("key-provider");
        if(required && result == null) {
            bomb("key-provider=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMatch() {
		boolean required = false;
        String result = getNamedParameter("match");
        if(required && result == null) {
            bomb("match=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getVolatile() {
		boolean required = false;
        String result = getNamedParameter("volatile");
        if(required && result == null) {
            bomb("volatile=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPartialBlock() {
		boolean required = false;
        String result = getNamedParameter("partial-block");
        if(required && result == null) {
            bomb("partial-block=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getEvenOdd() {
		boolean required = false;
        String result = getNamedParameter("even-odd");
        if(required && result == null) {
            bomb("even-odd=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getSource();
        getValue_();
        getIndex();
        getElement();
        getKeyExpression();
        getFullSource();
        getDefaultValue();
        getConverter();
        getPrimaryKeys();
        getKeyProvider();
        getMatch();
        getVolatile();
        getPartialBlock();
        getEvenOdd();
    }

    public void validateModel() {
        // check uniqueness
    }
}