package org.xdoclet.plugin.tapestry.qtags;

public class TacosTreeTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.TacosTreeTag {
    public static final String NAME = "tacos.tree";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"content-provider",
		"key-provider",
		"converter",
		"value",
		"state",
		"sorter",
		"offset",
		"row-style",
		"partial-block-class",
		"link-listener",
		"open-icon",
		"close-icon",
		"node-link-ajax",
		"delayed-load",
		"load-element",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public TacosTreeTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public TacosTreeTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getContentProvider() {
		boolean required = true;
        String result = getNamedParameter("content-provider");
        if(required && result == null) {
            bomb("content-provider=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getKeyProvider() {
		boolean required = false;
        String result = getNamedParameter("key-provider");
        if(required && result == null) {
            bomb("key-provider=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getConverter() {
		boolean required = false;
        String result = getNamedParameter("converter");
        if(required && result == null) {
            bomb("converter=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getValue_() {
		boolean required = true;
        String result = getNamedParameter("value");
        if(required && result == null) {
            bomb("value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getState() {
		boolean required = false;
        String result = getNamedParameter("state");
        if(required && result == null) {
            bomb("state=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSorter() {
		boolean required = false;
        String result = getNamedParameter("sorter");
        if(required && result == null) {
            bomb("sorter=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOffset() {
		boolean required = false;
        String result = getNamedParameter("offset");
        if(required && result == null) {
            bomb("offset=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRowStyle() {
		boolean required = false;
        String result = getNamedParameter("row-style");
        if(required && result == null) {
            bomb("row-style=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPartialBlockClass() {
		boolean required = false;
        String result = getNamedParameter("partial-block-class");
        if(required && result == null) {
            bomb("partial-block-class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLinkListener() {
		boolean required = false;
        String result = getNamedParameter("link-listener");
        if(required && result == null) {
            bomb("link-listener=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOpenIcon() {
		boolean required = false;
        String result = getNamedParameter("open-icon");
        if(required && result == null) {
            bomb("open-icon=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCloseIcon() {
		boolean required = false;
        String result = getNamedParameter("close-icon");
        if(required && result == null) {
            bomb("close-icon=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNodeLinkAjax() {
		boolean required = false;
        String result = getNamedParameter("node-link-ajax");
        if(required && result == null) {
            bomb("node-link-ajax=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDelayedLoad() {
		boolean required = false;
        String result = getNamedParameter("delayed-load");
        if(required && result == null) {
            bomb("delayed-load=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLoadElement() {
		boolean required = false;
        String result = getNamedParameter("load-element");
        if(required && result == null) {
            bomb("load-element=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getContentProvider();
        getKeyProvider();
        getConverter();
        getValue_();
        getState();
        getSorter();
        getOffset();
        getRowStyle();
        getPartialBlockClass();
        getLinkListener();
        getOpenIcon();
        getCloseIcon();
        getNodeLinkAjax();
        getDelayedLoad();
        getLoadElement();
    }

    public void validateModel() {
        // check uniqueness
    }
}