package org.xdoclet.plugin.tapestry.qtags;

public class ContribDateFieldTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.ContribDateFieldTag {
    public static final String NAME = "contrib.date-field";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"disabled",
		"hidden",
		"display-width",
		"maximum-length",
		"date",
		"display-name",
		"maximum",
		"minimum",
		"required",
		"format",
		"display-format",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public ContribDateFieldTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public ContribDateFieldTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisabled() {
		boolean required = false;
        String result = getNamedParameter("disabled");
        if(required && result == null) {
            bomb("disabled=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getHidden() {
		boolean required = false;
        String result = getNamedParameter("hidden");
        if(required && result == null) {
            bomb("hidden=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisplayWidth() {
		boolean required = false;
        String result = getNamedParameter("display-width");
        if(required && result == null) {
            bomb("display-width=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMaximumLength() {
		boolean required = false;
        String result = getNamedParameter("maximum-length");
        if(required && result == null) {
            bomb("maximum-length=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDate() {
		boolean required = true;
        String result = getNamedParameter("date");
        if(required && result == null) {
            bomb("date=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisplayName() {
		boolean required = true;
        String result = getNamedParameter("display-name");
        if(required && result == null) {
            bomb("display-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMaximum() {
		boolean required = false;
        String result = getNamedParameter("maximum");
        if(required && result == null) {
            bomb("maximum=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMinimum() {
		boolean required = false;
        String result = getNamedParameter("minimum");
        if(required && result == null) {
            bomb("minimum=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRequired() {
		boolean required = false;
        String result = getNamedParameter("required");
        if(required && result == null) {
            bomb("required=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getFormat() {
		boolean required = false;
        String result = getNamedParameter("format");
        if(required && result == null) {
            bomb("format=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisplayFormat() {
		boolean required = false;
        String result = getNamedParameter("display-format");
        if(required && result == null) {
            bomb("display-format=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getDisabled();
        getHidden();
        getDisplayWidth();
        getMaximumLength();
        getDate();
        getDisplayName();
        getMaximum();
        getMinimum();
        getRequired();
        getFormat();
        getDisplayFormat();
    }

    public void validateModel() {
        // check uniqueness
    }
}