package org.xdoclet.plugin.tapestry.qtags;

public class ContribPaletteTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.ContribPaletteTag {
    public static final String NAME = "contrib.palette";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"selected-title-block",
		"available-title-block",
		"model",
		"selected",
		"sort",
		"rows",
		"table-class",
		"select-image",
		"disabled-image",
		"deselect-image",
		"select-disabled-image",
		"deselect-disabled-image",
		"up-image",
		"up-disabled-image",
		"down-image",
		"down-disabled-image",
		"display-name",
		"htmlid",
		"validators",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public ContribPaletteTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public ContribPaletteTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSelectedTitleBlock() {
		boolean required = false;
        String result = getNamedParameter("selected-title-block");
        if(required && result == null) {
            bomb("selected-title-block=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAvailableTitleBlock() {
		boolean required = false;
        String result = getNamedParameter("available-title-block");
        if(required && result == null) {
            bomb("available-title-block=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getModel() {
		boolean required = true;
        String result = getNamedParameter("model");
        if(required && result == null) {
            bomb("model=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSelected() {
		boolean required = true;
        String result = getNamedParameter("selected");
        if(required && result == null) {
            bomb("selected=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSort() {
		boolean required = false;
        String result = getNamedParameter("sort");
        if(required && result == null) {
            bomb("sort=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRows() {
		boolean required = false;
        String result = getNamedParameter("rows");
        if(required && result == null) {
            bomb("rows=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTableClass() {
		boolean required = false;
        String result = getNamedParameter("table-class");
        if(required && result == null) {
            bomb("table-class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSelectImage() {
		boolean required = false;
        String result = getNamedParameter("select-image");
        if(required && result == null) {
            bomb("select-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisabledImage() {
		boolean required = false;
        String result = getNamedParameter("disabled-image");
        if(required && result == null) {
            bomb("disabled-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDeselectImage() {
		boolean required = false;
        String result = getNamedParameter("deselect-image");
        if(required && result == null) {
            bomb("deselect-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSelectDisabledImage() {
		boolean required = false;
        String result = getNamedParameter("select-disabled-image");
        if(required && result == null) {
            bomb("select-disabled-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDeselectDisabledImage() {
		boolean required = false;
        String result = getNamedParameter("deselect-disabled-image");
        if(required && result == null) {
            bomb("deselect-disabled-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getUpImage() {
		boolean required = false;
        String result = getNamedParameter("up-image");
        if(required && result == null) {
            bomb("up-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getUpDisabledImage() {
		boolean required = false;
        String result = getNamedParameter("up-disabled-image");
        if(required && result == null) {
            bomb("up-disabled-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDownImage() {
		boolean required = false;
        String result = getNamedParameter("down-image");
        if(required && result == null) {
            bomb("down-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDownDisabledImage() {
		boolean required = false;
        String result = getNamedParameter("down-disabled-image");
        if(required && result == null) {
            bomb("down-disabled-image=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisplayName() {
		boolean required = false;
        String result = getNamedParameter("display-name");
        if(required && result == null) {
            bomb("display-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getHtmlid() {
		boolean required = false;
        String result = getNamedParameter("htmlid");
        if(required && result == null) {
            bomb("htmlid=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getValidators() {
		boolean required = false;
        String result = getNamedParameter("validators");
        if(required && result == null) {
            bomb("validators=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getSelectedTitleBlock();
        getAvailableTitleBlock();
        getModel();
        getSelected();
        getSort();
        getRows();
        getTableClass();
        getSelectImage();
        getDisabledImage();
        getDeselectImage();
        getSelectDisabledImage();
        getDeselectDisabledImage();
        getUpImage();
        getUpDisabledImage();
        getDownImage();
        getDownDisabledImage();
        getDisplayName();
        getHtmlid();
        getValidators();
    }

    public void validateModel() {
        // check uniqueness
    }
}