package org.xdoclet.plugin.tapestry.qtags;

public class ContribTimeoutTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.ContribTimeoutTag {
    public static final String NAME = "contrib.timeout";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"warning-time",
		"auto-prolong-time",
		"warning-message",
		"expiration-message",
		"disable-warning",
		"disable-auto-prolong",
		"expiration-function",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public ContribTimeoutTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public ContribTimeoutTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getWarningTime() {
		boolean required = false;
        String result = getNamedParameter("warning-time");
        if(required && result == null) {
            bomb("warning-time=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAutoProlongTime() {
		boolean required = false;
        String result = getNamedParameter("auto-prolong-time");
        if(required && result == null) {
            bomb("auto-prolong-time=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getWarningMessage() {
		boolean required = false;
        String result = getNamedParameter("warning-message");
        if(required && result == null) {
            bomb("warning-message=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getExpirationMessage() {
		boolean required = false;
        String result = getNamedParameter("expiration-message");
        if(required && result == null) {
            bomb("expiration-message=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisableWarning() {
		boolean required = false;
        String result = getNamedParameter("disable-warning");
        if(required && result == null) {
            bomb("disable-warning=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisableAutoProlong() {
		boolean required = false;
        String result = getNamedParameter("disable-auto-prolong");
        if(required && result == null) {
            bomb("disable-auto-prolong=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getExpirationFunction() {
		boolean required = false;
        String result = getNamedParameter("expiration-function");
        if(required && result == null) {
            bomb("expiration-function=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getWarningTime();
        getAutoProlongTime();
        getWarningMessage();
        getExpirationMessage();
        getDisableWarning();
        getDisableAutoProlong();
        getExpirationFunction();
    }

    public void validateModel() {
        // check uniqueness
    }
}